package StarcityClient;

import java.awt.*;
import java.net.*;
import java.io.*;
import javax.swing.*;


class ClientIndexProtocol	{

      protected Connection            connection;
      protected String                address;
      protected int                   portnum;
      protected static Socket         clientSock = null;
      protected InputStreamReader     isr;
      protected BufferedReader        in;
      protected DataOutputStream      out = null;
      protected Manda                 mandante;
      static    int                   fileSala, postiSala;
      protected ClientIndexGui        window;
      protected Ricevi                ricevente;
      protected String                messaggio, risposta = "";
      protected int                   sala, spett;

      ClientIndexProtocol (ClientIndexGui window, String address, int portnum)  {
        this.window = window;
        this.address = address;
        this.portnum = portnum;
        try {
          connection = new Connection (address, portnum);
          clientSock = connection.clientSock;
          try {
            isr = new InputStreamReader(clientSock.getInputStream());
            in  = new BufferedReader(isr);
            out = new DataOutputStream(clientSock.getOutputStream());
          }
          catch (IOException e) {}
        }
        catch (IOException e) {
          System.out.println("Eccezione: impossibile creare la socket con il server: " + e.getMessage());
        }
      } // end costruttore
//------------------------------------------------------------------------------

      public void procedi() {
      Color c;

        for (int i = 0; i < window.NUMROWS; i++)	{
        	for (int j = 0; j < window.NUMCOLS; j++)	{
            c = window.p[i][j].getBackground();
            if (c == Color.pink)
              window.p[i][j].setBackground(Color.lightGray);
          }
        }

        // rileva i valori "sala" e "spettacolo"
        spett = ClientIndexGui.ComboSpettacolo.getSelectedIndex() + 1;
        sala = ClientIndexGui.ComboSala.getSelectedIndex() + 1;

        // Mi predispongo in modo da poter comunicare col server
        try {
          mandante = new Manda(out, clientSock);
          ricevente = new Ricevi (in, clientSock);
          mandante.start();
          ricevente.start();
        }
        catch(IOException e)  {
          System.out.println(e.getMessage());
        }

      // ora costruisco e invio il messaggio di richiesta al server
        MsgGetFreeSeat msgFree = new MsgGetFreeSeat(sala, spett);
        mandante.mandaMSG(msgFree.outMsg);
      //  System.out.println("\nHo mandato il messaggio: " + msgFree.outMsg);

      // Ricevo dal server l'elenco dei posti occupati
        messaggio = ricevente.riceviMSG();
      //  System.out.println("\nHo ricevuto il messaggio: " + messaggio);

      // Rappresento graficamente l'insieme dei posti occupati
        window.disegnaPostiOccupati(messaggio);

      } // END procedi

      public void prenota() {
      // Ora ricerco i posti in via di occupazione
        String richPosti = window.occupa();
        MsgBookingThis msgBTH = new MsgBookingThis(sala, spett, richPosti);
        mandante.mandaMSG(msgBTH.outMsg);

        risposta = ricevente.riceviMSG();
// System.out.println("Messaggio ricevuto dal server: risposta=" + risposta);        
        if (risposta.length() == 2)
          this.assegna();
        else
          this.assegna(messaggio.substring(2));
      }

//------------------------------------------------------------------------------
      
  public void assegna() {
    Color c;

    for (int i = 0; i < window.NUMROWS; i++)	{
    	for (int j = 0; j < window.NUMCOLS; j++)	{
        c = window.p[i][j].getBackground();
        if (c == Color.blue)
          window.p[i][j].setBackground(Color.red);
      }
    }
    FrameOk winOk = new FrameOk(this);
    winOk.show();
    winOk.resize(275, 175);
  }
//------------------------------------------------------------------------------
  
  public void assegna(String messaggio) {
    Color c;

    for (int i = 0; i < window.NUMROWS; i++)	{
    	for (int j = 0; j < window.NUMCOLS; j++)	{
        c = window.p[i][j].getBackground();
        if (c == Color.blue)
          window.p[i][j].setBackground(Color.pink);
      }
    }
    FrameErr winErr = new FrameErr(this);
    winErr.show();
    winErr.resize(275, 175);
  }
//------------------------------------------------------------------------------

}
