package StarcityServer;

import java.io.*;
import java.net.*;
import java.util.Iterator;
import java.awt.*;

/**
  * La classe ComClient rappresenta il thread che interagisce con il client,
  * gestendo i messaggi con esso.
  */

public class ComClient extends Thread {
   public final String        localFiles = "localFiles/";
   Socket actualClient;
   ServerStdProtocol currentProtocol;
   DataOutputStream outStream;
   BufferedReader bufferedReader;
   String IP;
   int Port;
   String messaggio = "", richiesta = "";
   String msgSL = "", nome = "";
   int inByte;
   String postiOccupati = "", response = "";


//------------------------------------------------------------------------------
 /**
   * Costruttore che prepara la socket per comunicare.
   */

   public ComClient(Socket actualClient, ServerStdProtocol currentProtocol) {

   super();
   this.actualClient = actualClient;
   this.currentProtocol = currentProtocol;
   
   try {

     IP = (actualClient.getInetAddress()).getHostAddress();
     Port = (actualClient.getPort());
     System.out.println("\n\nRilevato nuovo client:\n");
     System.out.println("Ip address: " + IP + "\nport on this sistem: " + Port + "\n\n");
     System.out.flush();

     InputStream        inputStream        = actualClient.getInputStream();
                        bufferedReader     = new BufferedReader(new InputStreamReader(inputStream));

                        outStream          = new DataOutputStream(actualClient.getOutputStream());
   }
   catch (IOException e) {}
  }

  /**
    * Metodo run() del Thread che viene invocato dal metodo start() in ListenClient
    * Consiste in un ciclo che viene interrotto al momento della disconnessione del Client
    */

  public void run() {
    boolean socketOn = true;

    while (socketOn)  {
      try {
        messaggio = bufferedReader.readLine();
        nome = messaggio.substring(0,3);

        if (nome.equals("GFS")) {
        //  System.out.println("Ho letto il messaggio: " + nome);
/**
  * SPEDISCO L'ELENCO DEI POSTI GIA' OCCUPATI
  * Nota: Devo averlo creato in precedenza nella cartella myprojects/starcityServer
  * Nota2: il file deve contenere gli indici dei posti su un'unica riga, separati
  * da uno spazio e terminare con uno spazio!
  */
          FileReader file = new FileReader(localFiles + messaggio.substring(3,5) + ".dat");
          do  {
            inByte = file.read();
            if (inByte != -1)
              msgSL = msgSL + (char) inByte;
          } while (inByte != -1);
          msgSL = msgSL + '\n';
          file.close();
          outStream.writeBytes(msgSL);
          outStream.flush();
          msgSL = "";   // Ho ricavato le informazioni dal file locale
        }

        if (nome.equals("BTH")) {
          //System.out.println("Ho letto il messaggio: " + nome);
          // richiesta = bufferedReader.readLine();
          // LEGGO LA RICHIESTA DEL CLIENT DEI POSTI DA ASSEGNARE
          // messaggio contiene i posti da occupare, compreso lo spettacolo
          //System.out.println("COMCLIENT Posti da occupare: richiesta=" + /*richiesta*/messaggio);
          // Come prima cosa registro la richiesta in un file temporaneo
          // Ricopio la richiesta come SalaSpettacolo Posto1 Fila1 SalaSpettacolo Posto2 Fila2 ...
          FileWriter temp = new FileWriter(localFiles + "temp.dat");
          temp.write(/*richiesta*/messaggio);  // Ricopio la richiesta pari pari
          temp.close();

          postiOccupati = currentProtocol.verifica(/*richiesta*/messaggio);

   /*       if (postiOccupati.length() == 0)
          System.out.println("I posti sono liberi. postiOccupati=" + postiOccupati);
          else
          System.out.println("I posti gia' occupati sono: postiOccupati=" + postiOccupati);
     */
          // Ora mi preparo a spedire la risposta al client
          FileWriter fileWR = new FileWriter(localFiles + messaggio.substring(3,5) + ".dat", true);
          //System.out.println("Messaggio per aprire il file in scrittura locale: messaggio.substring(3,5)=" + messaggio.substring(3,5));
          if (postiOccupati.length() == 0) {
            //System.out.println("POSTI LIBERI. I posti da occupare sono : richiesta.substring(6)=" + /*richiesta*/messaggio.substring(6));
            for (int i = 0; i < /*richiesta*/messaggio.substring(6).length(); i++)
              fileWR.write(/*richiesta*/messaggio.substring(6).charAt(i));
            response = "OK\n";
          }
          else  {
          //System.out.println("POSTI OCCUPATI. I posti da occupare sono: postiOccupati=" + postiOccupati);
            for (int i = 0; i < postiOccupati.length(); i++)
              fileWR.write(postiOccupati.charAt(i));
            response = "NO " + postiOccupati + '\n';
          }
          //System.out.println("Response to Client: response=" + response);
          fileWR.close();
          outStream.writeBytes(response);
          outStream.flush();
        } //END if
      }
      catch(IOException e)  {
        socketOn = false;
        System.out.println(e);
      }
    }
  }
}