package StarcityServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

/**
  * Questa classe estende la classe Thread in modo da gestire in modo multithreading
  * la comunicazione verso gli altri server che fanno parte del sistema realizzato.
  * Ogni oggetto di tipo ComServer viene creato nel thread ListenServer ed inserito
  * nella lista dei server attivi gestita dal protocollo corrente.
  */

public class ComServer extends Thread {

   public Socket            actualServer;
   public ServerStdProtocol currentProtocol;
   public DataOutputStream  outStream;
   public BufferedReader    bufferedReader;
   public int               listenServerPort;
   public int               listenClientPort;
   public String            IP;
   public int               port;
   public final String             remoteFiles = "remoteFiles/";
   protected Connection            connection;
   protected static Socket         clientSock = null;
   protected InputStreamReader     isr;
   protected BufferedReader        in;
   protected DataOutputStream      out = null;
   public    String                messaggio = "", risposta = "", posti = "", messaggioVE="";
   public    int                   inByte;
   public    String                postiOccupati = "";
   public    int                   DIM = 0;
   public    int                   numServer, numOtherServer;
   public    boolean               flag = true;
   public    String                confirm = "", intRich, intRicev;
   public    Integer               tmp;

//--------------------------------------------------------------------------

   /**
   * La socket appena creata dalla listening socket nel thread ListenServer,
   * il protocollo corrente ed un boolean che ci dice se siamo stati noi a
   * richiedere la connessione o meno mi permettono di dare inizio alla
   * comunciazione verso il server.
   */

public ComServer(Socket actualServer, ServerStdProtocol currentProtocol)  {
    super();
    this.actualServer    = actualServer;
    this.currentProtocol = currentProtocol;

    try {
      isr = new InputStreamReader(actualServer.getInputStream());
      in  = new BufferedReader(isr);
      out = new DataOutputStream(actualServer.getOutputStream());

    }
    catch (IOException e) {}

    if (currentProtocol.numServer == 1) {
      IP = (actualServer.getInetAddress()).getHostAddress();
      port = (actualServer.getPort());
      System.out.println("\n\nRilevato nuovo server:\n");
      System.out.println("Ip address: " + IP + "\nport on this sistem: " + port + "\n\n");
    }
}

public void run() {

   while(flag == true) {
       try {
          messaggio = in.readLine();
          //System.out.println("messaggio ricevuto=" + messaggio);

          if (messaggio.length() == 2) {   // Ho ricevuto "no" dall'altro server
        //    this.flag = false;
            out.writeBytes ("confirm");
            out.write(13);
            out.write(10);
            out.flush();
          }
          else  {
            //System.out.println("\tPriorita' server:" + messaggio.substring(0,1) + ". Posti da occupare: messaggio=" + messaggio.substring(1));

            numOtherServer = tmp.valueOf(messaggio.substring(0,1)).intValue();
            messaggio =messaggio.substring(1);
            out.writeBytes("no");
            out.write(13);
            out.write(10);
            out.flush();
            confirm = in.readLine();
            //System.out.println ("\nHo letto :" + confirm);
            out.writeBytes(controlla(messaggio));
            out.flush();
       }           

     }
        catch (IOException e) {}    
   }
}
//------------------------------------------------------------------------------

public String controlla (String messaggio) {
     String copia = "";
     String[] lista;
     this.messaggio = messaggio;
     /* LEGGO IL FILE DEI POSTI E METTO L'ELENCO DEI POSTI IN "copia" */
     try  {
        FileReader fileRD = new FileReader(remoteFiles + "temp.dat");
        do  {
          inByte = fileRD.read();
          if (inByte != -1)
            copia = copia + (char) inByte;
        } while (inByte != -1);
        fileRD.close();
     }
     catch (IOException e)  {}

     intRich = messaggio.substring(0,5);
     //System.out.println("Intestazione Server Richiedente:" + intRich);
//     System.out.println("Stringa Scritta da me:" + copia + "FINE");
     /* ELIMINO L'INTESTAZIONE DEL MESSAGGIO */
     posti = messaggio.substring(5);
//     System.out.println("\n Il messaggio senza intestazione e': posti da occupare=" + posti);
     if (copia == "")
        postiOccupati = "";
     else {
        intRicev = copia.substring(0,5);
//        System.out.println("Intestazione Server Ricevente:" + intRicev);

      // CONTROLLO CHE GLI STESSI POSTI NON SIANO IN VIA DI ASSEGNAMENTO SU QUESTO SERVER

         if (intRich.equals(intRicev)) {
//         System.out.println("\nLe due intestazioni sono uguali.");
             copia = copia.substring(5);
             /* METTO TUTTE LE COPPIE DEI POSTI RICHIESTI IN UN ARRAY */
             DIM = calcolaDIM(posti);
             lista = new String[DIM];
             lista = estraiCoppie (posti, DIM);
             for (int r = 0; r < DIM; r++)
               System.out.println(lista[r]);

             /* CONFRONTO LA RICHIESTA CON I POSTI GIA' OCCUPATI */
             postiOccupati = confronta (lista, copia);
          }
      } //end ELSE
//         System.out.println("Elenco posti occupati:" + postiOccupati);
  //       System.out.println("Lunghezza postiOccupati:" + postiOccupati.length());
         try  {
          FileWriter fileWR = new FileWriter(remoteFiles + messaggio.substring(3,5) + ".dat", true);
    //      System.out.println("Msg per aprire il file in WR: messaggio.substring(3,5)=" + messaggio.substring(3,5));
          if (postiOccupati.length() == 0) {
      //      System.out.println("I posti richiesti sono tutti liberi. Occupo i posti:" + posti);
            for (int i = 1; i < posti.length(); i++)
              fileWR.write(posti.charAt(i));
          }
          else  {
        //    System.out.println("I posti richiesti sono occupati. Occupo i posti:" + postiOccupati);
            for (int i = 1; i < postiOccupati.length(); i++)
              fileWR.write(postiOccupati.charAt(i));
          }
          fileWR.close();
         }
         catch (IOException e)  {}
         postiOccupati = postiOccupati + '\n';

         return postiOccupati;
}  // END controlla
//------------------------------------------------------------------------------

  public int calcolaDIM (String messaggio) {
  int dim = 0;
     for (int k = 0; k < messaggio.length(); k++)  {
       if (messaggio.charAt(k) == ' ')
         dim = dim + 1;
     }
     dim = dim / 2;
     return dim;
  }
//------------------------------------------------------------------------------

  public String[] estraiCoppie (String messaggio, int dim) {
     String[] elenco = new String[dim];
     char ch;
     String temp = "";
     int a = 0, spazio = 0;
     for (int i = 1; i < messaggio.length();)  {
       do  {
         ch = messaggio.charAt(i);
         if (ch != ' ')
            temp = temp + ch;
         else {
            temp = temp + ' ';
            spazio++;
         }
         i += 1;
       } while (spazio < 2);
       elenco[a] = temp;
       temp = "";
       a += 1;
       spazio = 0;
     }
     return elenco;
  }
        // In questo modo mi sono creato un array di sottostringhe contenente
        // tutte le coppie fila-posto
//------------------------------------------------------------------------------

  public String confronta (String list[], String messaggio) {
      int index;
      String temp = "";
      String occupati = "";
      for (index = 0; index < list.length; index++) {
//      System.out.println("list[index] = " + list[index]);
        temp = find(list[index], messaggio);
        occupati = occupati + temp;
      }
      return occupati;
  }
//------------------------------------------------------------------------------

  public String find (String s1, String s2)  {
    char ch;
    String temp = "";
    if (numServer < numOtherServer) {
      for (int t = 1; t < s2.length();) {
  //      System.out.println("Confronto la fila: " + s1.charAt(0) + " con " + s2.charAt(t));
        if(s1.charAt(0) == s2.charAt(t))  {
          if (s1.charAt(2) == s2.charAt(t+2))
            if (s1.charAt(3) == ' ')
              temp = temp + s1.charAt(0) + ' '+ s1.charAt(2) + ' ';
            else
              if (s1.charAt(3) == s2.charAt(t+3))
                temp = temp + s1.charAt(0) + ' ' + s1.charAt(2) + s1.charAt(3) + ' ';
        }
        if (s2.charAt(t+3) == ' ')
          t += 4;
        else
          t += 5;
      }
    }
    return temp;
  }
//------------------------------------------------------------------------------

public String verifica (String messaggioVE) {
    this.messaggioVE = messaggioVE;
    try {
      messaggioVE = messaggioVE + '\n';
      out.writeBytes(currentProtocol.numServer + messaggioVE);
      out.flush();
      risposta = in.readLine();
    //  System.out.println("Ho ricevuto la risposta: " + risposta);
    }
    catch (IOException e) {}
    return risposta;
}
//------------------------------------------------------------------------------
}