package StarcityServer;

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;

/**
  * Questa classe estende la classe Thread in modo da gestire in modo multithreading
  * la comunicazione verso gli altri server che fanno parte del sistema realizzato.
  * Ogni oggetto di tipo ComServerServer viene creato da ServerStdProtocol
  */

public class ComServerServer extends Thread {
  public    String                address = "localhost";
  public final String             remoteFiles = "remoteFiles/";
  public    int                   serverNumPort;
  public    Connection            connection;
  public    ComServer             comServer;
  public    ServerStdProtocol     currentProtocol;
  protected static Socket         clientSock = null;
  protected InputStreamReader     isr;
  protected BufferedReader        in;
  protected DataOutputStream      out = null;
  public    String                messaggio = "", risposta = "", posti = "";
  public    int                   inByte;
  public    String                postiOccupati = "";
  public    int                   DIM = 0;

  public ComServerServer(int serverNumPort, ServerStdProtocol currentProtocol) {
    super();
    this.serverNumPort    = serverNumPort;
    this.currentProtocol  = currentProtocol;


          try {
            isr = new InputStreamReader(clientSock.getInputStream());
            in  = new BufferedReader(isr);
            out = new DataOutputStream(clientSock.getOutputStream());
          }
          catch (IOException e) {}


  }

  public void run() {
    boolean flag = true;

    while(true) {
        try {
          messaggio = in.readLine();
System.out.println("posti da occupare: messaggio=" + messaggio);
//System.out.println("\nSono dentro ComServerServer del Server2. \nHo ricevuto il messaggio : " + messaggio + '@');

          out.writeBytes(controlla(messaggio));
          out.flush();

        }
        catch (IOException e) {
          flag = false;
        }
    }

  }

  public String controlla (String messaggio) {
     String copia = "";
     String[] lista;
     this.messaggio = messaggio;
/* LEGGO IL FILE DEI POSTI E METTO L'ELENCO DEI POSTI IN "copia" */
//System.out.println("\n Sono dentro il metodo controlla di ComServerServer di ComServerServer");
     try  {
        FileReader fileRD = new FileReader(remoteFiles + messaggio.substring(3,5) + ".dat");
System.out.println("Msg ricevuto per aprire il file: messaggio.substring(3,5)=" + messaggio.substring(3,5));

        do  {
          inByte = fileRD.read();
          if (inByte != -1)
            copia = copia + (char) inByte;
        } while (inByte != -1);
 //       copia = copia + '\n';
        fileRD.close();
     }
     catch (IOException e)  {}

System.out.println("\n L'elenco dei posti gia' occupati e': copia=" + copia);

/* ELIMINO L'INTESTAZIONE DEL MESSAGGIO */
     posti = messaggio.substring(5);
System.out.println("\n Il messaggio senza intestazione e': posti=" + posti);

/* METTO TUTTE LE COPPIE DEI POSTI RICHIESTI IN UN ARRAY */
     DIM = calcolaDIM(posti);
//System.out.println("La dimensione dell'array e': " + DIM);
     lista = new String[DIM];
     lista = estraiCoppie (posti, DIM);
//System.out.println("\n L'elenco delle coppie fila-posto e': \n\t");
for (int r = 0; r < DIM; r++)
  System.out.println(lista[r]);

/* CONFRONTO LA RICHIESTA CON I POSTI GIA' OCCUPATI */
     postiOccupati = confronta (lista, copia);
System.out.println("Elenco posti occupati: popstiOccupati=" + postiOccupati);
    try  {
      FileWriter aggiornamento = new FileWriter(remoteFiles + messaggio.substring(3,5) + ".dat", true);
System.out.println("Msg per aprire il file in WR: messaggio.substring(3,5)=" + messaggio.substring(3,5));
      if (postiOccupati.length() == 0) {
//        System.out.println("I posti richiesti sono tutti liberi. Posso occuparli! Posti occupati: " + postiOccupati);
        for (int i = 1; i < posti.length(); i++)
          aggiornamento.write(posti.charAt(i));
        aggiornamento.close();
      }
     }
     catch (IOException e)  {}
     postiOccupati = postiOccupati + '\n';

//System.out.println("\nSto per ritornare i posti gi occupati. Sono: " + postiOccupati);
    return postiOccupati;
  }  // END controlla

//------------------------------------------------------------------------------

  public int calcolaDIM (String messaggio) {
  int dim = 0;
     for (int k = 0; k < messaggio.length(); k++)  {
       if (messaggio.charAt(k) == ' ')
         dim = dim + 1;
     }
     dim = dim / 2;  // System.out.println("Dimensione array = " + DIM);
     return dim;
  }
//------------------------------------------------------------------------------

  public String[] estraiCoppie (String messaggio, int dim) {
     String[] elenco = new String[dim];
     char ch;
     String temp = "";
     int a = 0, spazio = 0;
//System.out.println("Sono dentro estraiCoppie. Il messaggio e' : " + messaggio);
     for (int i = 1; i < messaggio.length();)  {
       do  {
         ch = messaggio.charAt(i);
         if (ch != ' ')
            temp = temp + ch;
         else {
            temp = temp + ' ';
            spazio++;
         }
         i += 1;
       } while (spazio < 2);
       // System.out.println("Coppia numero: " + a);
       elenco[a] = temp;
       temp = "";
       // System.out.println("Coppia " + a + " dell'array: " + lista[a]);
       a += 1;
       spazio = 0;
     }
     return elenco;
  }
        // In questo modo mi sono creato un array di sottostringhe contenente
        // tutte le coppie fila-posto
//------------------------------------------------------------------------------

  public String confronta (String list[], String messaggio) {
      int index;
      String temp = "";
      String occupati = "";
//System.out.println("Ora sono dentro confronta.");
//System.out.println("Lunghezza lista = " + list.length);
//System.out.println("Lunghezza messaggio = " + messaggio.length());
      for (index = 0; index < list.length; index++) {
//System.out.println("list[index] = " + list[index]);
        temp = find(list[index], messaggio);
        occupati = occupati + temp;
      }
      return occupati;
  }
//------------------------------------------------------------------------------

  public String find (String s1, String s2)  {
    char ch;
    String temp = "";
//System.out.println("\nOra sono dentro find.");
//System.out.println("Lunghezza lista = " + s1.length());
//System.out.println("Lunghezza messaggio = " + s2.length());
//System.out.println("Elenco posti occupati: " + s2);
    //for (int s = 0; s < s1.length();) {
      for (int t = 0; t < s2.length();) {
//System.out.println("Confronto la fila: " + s1.charAt(0) + " con " + s2.charAt(t));
        if(s1.charAt(0) == s2.charAt(t)) {
          if (s1.charAt(2) == s2.charAt(t+2)) {
            if (s1.charAt(3) == ' ')
              temp = temp + s1.charAt(0) + ' '+ s1.charAt(2) + ' ';
            else
              if (s1.charAt(3) == s2.charAt(t+3)) {
//System.out.println("Confronto il secondo numero del posto: " + s1.charAt(3) + " con " + s2.charAt(t+3));
                temp = temp + s1.charAt(0) + ' ' + s1.charAt(2) + s1.charAt(3) + ' ';
              }
           }
        }
        if (s2.charAt(t+3) == ' ')
          t += 4;
        else
          t += 5;
      }
      /*if (s == (s1.length()-4))
        s += 3;
      else
        s +=4;
    }         */
    return temp;
  }
//------------------------------------------------------------------------------

 /* public String verifica (String messaggio) {
    comServer = new ComServer (clientSock, currentProtocol);
    comServer.start();
    return comServer.verifica(messaggio);
  }  */
}