package StarcityServer;

import java.net.*;
import java.io.IOException;

/**
  * Thread che si mette in ascolto dei client che si vogliono connettere, accetta
  le connessioni e genera un altro thread che si gestisce la comunicazione vera
  e propria.
  */

public class ListenClient extends Thread {

  ServerSocket        listenClient;
  Socket              actualClient;
  ServerStdProtocol   currentProtocol;
  ComClient           client;

  public ListenClient(ServerSocket listenClient, ServerStdProtocol currentProtocol) {
    super();
    this.listenClient = listenClient;
    this.currentProtocol = currentProtocol;
  }

/**
  * Il thread rimane in attesa che un cliente richieda la connessione. Quando
  * ci avviene genera un altro thread
  */

  public void run ()  {
    while (true)  {
      try {
        actualClient = listenClient.accept();
      }
      catch (IOException e) {}
      client = new ComClient(actualClient, currentProtocol);
      client.start();
    }
  }
}