package StarcityServer;

import java.io.*;
import java.net.*;

/**
  * Thread che si mette in ascolto dei server che si vogliono connettere,
  * accetta le connessioni e genera un altro threadche gestisce la comunicazione
  * vera e propria.
  */

public class ListenServer extends Thread {


  ServerSocket        listenerServer;
  Socket              actualServer;
  ServerStdProtocol   currentProtocol;
  ComServer       comServer;
  ComServerServer comServerServer;
  String messaggio = "";

  public ListenServer(ServerSocket listenerServer, ServerStdProtocol currentProtocol) {
    super();
    this.listenerServer   = listenerServer;
    this.currentProtocol  = currentProtocol;
  }

/**
  * Il thread rimane in attesa che un server richieda la connessione; quando ci
  * avviene genera un altro thread che si occupa di gestire la comuncazione vera
  * e propria.
  */

  public void run() {
    while (true)  {
        try {
          actualServer = listenerServer.accept();
        }
        catch (IOException e) {}

        comServer = new ComServer (actualServer, currentProtocol);
        comServer.start();
    }
  }

  public String verifica (String messaggio) {
    this.messaggio = messaggio;
  //  System.out.println("\nSono dentro a ListenServer del Server1: messaggio = " + messaggio);
    return comServer.verifica(messaggio);
  }
}